]> git.phdru.name Git - dotfiles.git/blob - .shellrc
.shellrc: Fix the list of remotes
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 OPS1="$OPS1\\$"
62 PS1="$OPS1 "
63
64
65 if test -n "$BASH_VERSION"; then
66    [ "`type -t ls`" = alias ] && unalias ls
67    [ "`type -t ll`" = alias ] && unalias ll
68    [ "`type -t mc`" = alias ] && unalias mc
69
70    back() { cd - "$@"; }
71    functions() { typeset -f "$@"; }
72    j() { jobs; }
73
74    has_completion() { return 0; }
75    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
76       if [ "$SHELL" = /bin/bash ]; then
77          if [ -d /usr/share/bash-completion ]; then
78             . /usr/share/bash-completion/bash_completion
79             has_completion() { [ -r /usr/share/bash-completion/completions/$1 ]; }
80          elif [ -f /etc/bash_completion ]; then
81             . /etc/bash_completion
82             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
83          elif [ -d /etc/bash_completion.d ]; then
84             for _compf in /etc/bash_completion.d/*; do
85                . $_compf
86             done
87             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
88          fi
89       elif [ "$SHELL" = /usr/local/bin/bash ]; then
90          if [ -d /usr/local/etc/bash_completion.d ]; then
91             for _compf in /usr/local/etc/bash_completion.d/*; do
92                . $_compf
93             done
94             has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
95          fi
96       else
97          echo "Unknown OS type, cannot source bash_completion" >&2
98       fi
99    fi
100
101    if [ -d "$HOME"/.bash_completion.d ]; then
102       for _compf in "$HOME"/.bash_completion.d/*; do
103          . $_compf
104       done
105    fi
106
107    for cmd in builtin cgmem_nice command dbus-launch exec \
108       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
109       time whence whereis which xargs; do
110          ! has_completion $cmd && complete -o default -A command $cmd
111    done
112
113    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
114       telnet t tt \
115       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
116       whois wget wget-m wget-wrapper ww; do
117          ! has_completion $cmd && complete -A hostname $cmd
118    done
119
120    for cmd in distribute ftp lftp r rsync \
121       s scp ssh smbclient tcpdump tshark wireshark; do
122          ! has_completion $cmd && complete -o default -A hostname $cmd;
123    done
124
125    delegate_completion() {
126       local prog programs
127       prog=$1
128       if has_completion $prog; then
129          shift
130          programs="$@"
131          eval "_${prog}_completion_loader() {
132             _completion_loader $prog
133             complete -F _$prog $programs
134             unset _${prog}_completion_loader
135             return 124
136          }"
137          complete -F _${prog}_completion_loader $programs
138       fi
139    }
140
141    delegate_completion make m
142    delegate_completion ping p
143    delegate_completion rsync r rsync_cgmn rsync_cgmn_recode
144    delegate_completion ssh s
145    delegate_completion wget wget-m wget-wrapper ww
146
147    unset has_completion delegate_completion
148
149    complete -A job bg fg j jobs wait
150    complete -A variable -A function unset
151
152    if [ -d "$HOME/lib/config" ]; then
153       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
154    fi
155    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
156
157    #if type -p pip >/dev/null 2>&1; then
158    #   eval "`pip completion --bash`"
159    #   rm -rf /tmp/pip_build_"$USER"
160    #fi
161
162    #if which pyenv >/dev/null 2>&1; then
163    #   eval "`pyenv init -`"
164    #   eval "`pyenv virtualenv-init -`"
165    #fi
166
167    source virtualenvwrapper_lazy.sh 2>/dev/null
168
169    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
170       . "$VIRTUAL_ENV/bin/activate"
171    fi
172
173    # Clean up python virtual environment on exit
174    # See https://virtualenvwrapper.readthedocs.io/en/latest/tips.html#clean-up-environments-on-exit
175
176    trap '[ "$VIRTUAL_ENV" ] && deactivate' EXIT
177
178 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
179    back() { cd - "$@"; }
180    j() { jobs; }
181 fi
182
183
184 # clear screen and history, logout
185 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
186
187
188 if test -x /usr/bin/git >/dev/null 2>&1; then
189    # chdir to a directory
190    cdgitpath() {
191       if [ -z "$1" -o -n "$2" ]; then
192          echo "Usage: cdgitpath path_key" >&2
193          return 1
194       else
195          path_key="$1"
196       fi
197
198       if [ -z "$path_key" ]; then
199          echo "Usage: cdgitpath path_key" >&2
200          return 1
201       fi
202
203       cd "`git config --get --path $path_key`"
204    }
205
206    # chdir to a remote's directory (if the remote is on the local FS)
207    cdremote() {
208       if [ -z "$1" ]; then
209          branch="`git rev-parse --abbrev-ref HEAD`"
210          remote="`git config --get branch.$branch.remote`"
211       elif [ -n "$2" ]; then
212          echo "Usage: cdremote [remote_name]" >&2
213          return 1
214       else
215          remote="$1"
216       fi
217
218       if [ -z "$remote" ]; then
219          echo "Cannot find remote for branch $branch" >&2
220          echo "Usage: cdremote [remote_name]" >&2
221          return 1
222       fi
223
224       if git config --get remote.$remote.url | grep -q '^\(/\|\.\./\)'; then
225          cdgitpath remote.$remote.url
226       else
227
228          if [ -n "$1" ]; then
229             echo "Cannot find directory for remote $1" >&2
230             echo "Usage: cdremote [remote_name]" >&2
231             return 1
232          fi
233
234          _list_remotes '^\(/\|\.\./\)' # (/ or ../ at the beginning)
235          if [ ${#GIT_REMOTES[*]} -eq 1 ]; then
236             remote=${GIT_REMOTES[0]}
237             unset GIT_REMOTES
238             cdgitpath remote.$remote.url
239          else
240             unset GIT_REMOTES
241             echo "Cannot find directory for any remote" >&2
242             echo "Usage: cdremote [remote_name]" >&2
243             return 1
244          fi
245       fi
246    }
247
248    if test -n "$BASH_VERSION"; then
249       # completion for aliases in global .gitconfig
250
251       # fixup rbi rbia rbiap rbip - do refs name completion
252       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
253       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
254       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
255       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
256       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
257       #
258       # push-to-all-remotes - do branch name completion
259       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
260
261       _cdgitpath_completion_loader() {
262          _completion_loader git
263          complete -F _cdgitpath_complete cdgitpath git-open
264          unset _cdgitpath_completion_loader
265          return 124
266       }
267
268       _cdgitpath_complete() {
269          local cword="${COMP_CWORD}" cur="${COMP_WORDS[COMP_CWORD]}";
270          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
271       }
272
273       _git_open() {
274          _cdgitpath_complete
275       }
276
277       complete -F _cdgitpath_completion_loader cdgitpath git-open
278
279       # list remotes with URLs matching a regexp
280       _list_remotes() {
281          if [ -z "$1" -o -n "$2" ]; then
282             echo "Usage: _list_remotes remote_regexp" >&2
283             return 1
284          fi
285          declare -ag GIT_REMOTES=()
286          local remote
287          for remote in `git remote`; do
288             if git config --get remote.$remote.url | grep -q "$1"; then
289                GIT_REMOTES+=($remote)
290             fi
291          done
292       }
293
294       # completion for cdremote and git-open-remote - list remotes with a pattern
295       _list_remotes_completion() {
296          local cur="${COMP_WORDS[COMP_CWORD]}";
297          _list_remotes "$1"
298          COMPREPLY=(`compgen -W "${GIT_REMOTES[*]}" -- "$cur"`)
299          unset GIT_REMOTES
300       }
301
302       # completion for cdremote - list remotes with directories as URLs
303       _cdremote_complete() {
304          _list_remotes_completion '^\(/\|\.\./\)' # (/ or ../ at the beginning)
305          if [ ${#COMPREPLY[*]} -eq 0 ]; then
306             _list_remotes_completion .
307          fi
308       }
309
310       complete -F _cdremote_complete cdremote
311
312       # completion for git-open-remote - list remotes with http(s) URLs
313       _git_open_remote() {
314          _list_remotes_completion '^http\(s\)\?://'
315          if [ ${#COMPREPLY[*]} -eq 0 ]; then
316             _list_remotes_completion .
317          fi
318       }
319
320       complete -F _git_open_remote git-open-remote
321    fi
322 fi
323
324
325 include() {
326    cfg="$1"
327    if [ -f "./$cfg" -a -r "./$cfg" ]; then
328       echo "Reading config file \`$cfg'" 1>&2
329       . "./$cfg"
330    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
331       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
332       . "$HOME/lib/config/$cfg"
333    else
334       echo "Cannot find config file \`$cfg'" 1>&2
335    fi
336 }
337
338
339 mc() {
340    if test -n "$BASH_VERSION"; then
341       MC_SAVE_OPS1="$OPS1"
342       OPS1="\u@\h "
343    fi
344
345    if [ -n "$SLOWTERM" ]; then
346       MC_SLOW="--slow"
347    fi
348
349    case "$TERM" in
350       screen*) # screen, screen.rxvt
351          MC_XTERM="-x"
352       ;;
353    esac
354
355    #TMPDIR="$HOME"/tmp
356    #export TMPDIR
357
358    MC_FOUND=NO
359
360    for wrapper in \
361          /usr/local/share/mc/bin/mc-wrapper.sh \
362          /usr/local/libexec/mc/mc-wrapper.sh \
363          /usr/share/mc/bin/mc-wrapper.sh; do
364       if [ -r $wrapper ]; then
365          . $wrapper $MC_SLOW $MC_XTERM "$@"
366          rc=$?
367          MC_FOUND=YES
368          break
369       fi
370    done
371
372    if [ $MC_FOUND = NO ]; then
373       for mc in /usr/local/bin/mc /usr/bin/mc; do
374          if [ -x $mc ]; then
375             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
376             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
377                MC_TMP_DIR="${TMPDIR-/tmp}"
378             fi
379             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
380             mc_type="`mc_type.py $mc`"
381             if [ "$mc_type" = old ]; then
382                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
383             elif [ "$mc_type" = new ]; then
384                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
385             else
386                continue
387             fi
388             rc=$?
389             MC_FOUND=YES
390             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
391             break
392          fi
393       done
394    fi
395
396    if [ $MC_FOUND = NO ]; then
397       echo "Cannot find mc-wrapper.sh or mc" >&2
398       rc=1
399    fi
400
401    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
402    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SLOW MC_TMP_DIR MC_XTERM
403
404    return $rc
405 }
406
407
408 mkcd() {
409    if [ $# -ne 1 ]; then
410       echo "Usage: mkcd directory_name" >&2
411    elif [ -d "$1" ]; then
412       cd "$1"
413    elif [ -e "$1" ]; then
414       echo "Error: $1 is a file" >&2
415    else
416       mkdir -p "$1" && cd "$1"
417    fi
418 }
419
420
421 if which tmux >/dev/null 2>&1; then
422    tmux() {
423       case "$TERM" in
424          rxvt)
425             TERM=rxvt-unicode command tmux "$@"
426          ;;
427
428          *)
429             command tmux "$@"
430          ;;
431       esac
432    }
433 fi
434
435
436 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
437    X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
438 fi
439
440 x() { exit; }